<script>
  import back from "../../plugins/axios";

  let backurl = import.meta.env.VITE_BACKEND;

  /**
   * @type {HTMLInputElement}
   */
  let file_input;
  /**
   * @type {HTMLImageElement}
   */
  let img;
  let alert = "";
  let success = "";

  function update() {
    // back put the image on /website/logo
    let formData = new FormData();
    // @ts-ignore
    formData.append("logo_file", file_input.files[0]);
    back.put("/website/logo", formData).then((rep) => {
      if (rep.status == 200) {
        // @ts-ignore
        img.src = backurl + "website/logo?" + new Date().getTime();
        success = "Logo mis à jour !";
        alert = "";
      } else {
        alert = "Erreur lors de la mise à jour du logo";
        success = "";
      }
      setTimeout(() => {
        alert = "";
        success = "";
      }, 5000);
    });
  }
</script>

<div class="w-full h-full max-w-md items-center self-center">
  <form
    class="bg-secondary h-full shadow-md items-center rounded px-8 pt-6 pb-8 mb-4"
    on:submit|preventDefault={update}
  >
    <!-- alert & success -->
    {#if alert}
      <div
        class="bg-red-100 border border-red-400 text-red-700 px-4 py-3 rounded relative mt-2 mb-2"
        role="alert"
      >
        <strong class="font-bold">Erreur !</strong>
        <span class="block sm:inline">{alert}</span>
      </div>
    {/if}
    {#if success}
      <div
        class="bg-green-100 border border-green-400 text-green-700 px-4 py-3 rounded relative mt-2 mb-2"
        role="alert"
      >
        <strong class="font-bold">Succès !</strong>
        <span class="block sm:inline">{success}</span>
      </div>
    {/if}
    <div class="mb-4">
      <label class="block text-gray-700 text-sm font-bold mb-2" for="name">
        Logo de l'évènement
      </label>
      <!-- file -->
      <div class="flex items-center justify-center w-full">
        <label
          class="flex flex-col border-4 border-dashed w-full h-32 hover:bg-gray-100 hover:border-purple-300 group"
        >
          <div class="flex flex-col items-center justify-center pt-7">
            <svg
              class="w-10 h-10 text-purple-400 group-hover:text-purple-600"
              fill="none"
              stroke="currentColor"
              viewBox="0 0 48 48"
              xmlns="http://www.w3.org/2000/svg"
            >
              <path
                stroke-linecap="round"
                stroke-linejoin="round"
                stroke-width="2"
                d="M14 44v-8a2 2 0 012-2h20a2 2 0 012 2v8m-4-4h-4m-8 0H6"
              />
              <path
                stroke-linecap="round"
                stroke-linejoin="round"
                stroke-width="2"
                d="M14 34l7-7 7 7m-7-7v18"
              />
            </svg>
            <p
              class="lowercase text-sm text-gray-400 group-hover:text-purple-600 pt-1 tracking-wider"
            >
              Choisir un fichier
            </p>
          </div>
          <input
            type="file"
            class="hidden"
            bind:this={file_input}
            accept="image/*"
          />
        </label>
      </div>
    </div>
    <div class="mb-4">
      <label class="block text-gray-700 text-sm font-bold mb-2" for="name">
        Aperçu :
      </label>
      <img
        width="100px"
        height="100px"
        bind:this={img}
        src="{backurl}website/logo"
        alt="Logo de l'évènement"
      />
    </div>
    <div class="flex items-center justify-between">
      <button
        class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded focus:outline-none focus:shadow-outline"
        type="button"
        on:click={update}
      >
        Envoyer
      </button>
    </div>
  </form>
</div>
